import se.chalmers.cs.gf.abssyn.*;
import se.chalmers.cs.gf.linearize.*;
import se.chalmers.cs.gf.parse.*;

import java.io.*;
import java.util.*;

public class TestParser {

        public static void main(String[] args) throws Exception {
                if (args.length != 1) {
                        System.err.println("Usage: java TestParser <parser class name>");
                        System.exit(1);
                }

                String parserClassName = args[0];
                Class parserClass = Class.forName(parserClassName);
                Parser p = (Parser)parserClass.newInstance();

                BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
                String line;
                while ((line = in.readLine()) != null) {
                        Collection<Tree> ts = p.parse(line);
                        if (ts.size() == 0) {
                                System.out.println("<no parse>");
                        } else if (ts.size() == 1) {
                                System.out.println(ts.iterator().next().toString());
                        } else {
                                System.out.println("<Ambiguous parse:>");
                                for (Tree t : ts) 
                                        System.out.println(t.toString());
                        }
                }
        }

}
