package CFG;
import CFG.Absyn.*;

public class PrettyPrinter
{
  //For certain applications increasing the initial size of the buffer may improve performance.
  private static final int INITIAL_BUFFER_SIZE = 128;
  //You may wish to change the parentheses used in precedence.
  private static final String _L_PAREN = new String("(");
  private static final String _R_PAREN = new String(")");
  //You may wish to change render
  private static void render(String s)
  {
    if (s.equals("{"))
    {
       buf_.append("\n");
       indent();
       buf_.append(s);
       _n_ = _n_ + 2;
       buf_.append("\n");
       indent();
    }
    else if (s.equals("(") || s.equals("["))
       buf_.append(s);
    else if (s.equals(")") || s.equals("]"))
    {
       backup();
       buf_.append(s);
       buf_.append(" ");
    }
    else if (s.equals("}"))
    {
       _n_ = _n_ - 2;
       backup();
       backup();
       buf_.append(s);
       buf_.append("\n");
       indent();
    }
    else if (s.equals(","))
    {
       backup();
       buf_.append(s);
       buf_.append(" ");
    }
    else if (s.equals(";"))
    {
       backup();
       buf_.append(s);
       buf_.append("\n");
       indent();
    }
    else if (s.equals("")) return;
    else
    {
       buf_.append(s);
       buf_.append(" ");
    }
  }


  //  print and show methods are defined for each category.
  public static String print(CFG.Absyn.Grammars foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Grammars foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Grammar foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Grammar foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListGrammar foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListGrammar foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Flag foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Flag foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListFlag foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListFlag foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Rule foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Rule foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListRule foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListRule foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Profile foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Profile foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Ints foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Ints foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListInts foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListInts foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListInteger foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListInteger foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Symbol foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Symbol foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.ListSymbol foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.ListSymbol foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Name foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Name foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String print(CFG.Absyn.Category foo)
  {
    pp(foo, 0);
    trim();
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  public static String show(CFG.Absyn.Category foo)
  {
    sh(foo);
    String temp = buf_.toString();
    buf_.delete(0,buf_.length());
    return temp;
  }
  /***   You shouldn't need to change anything beyond this point.   ***/

  private static void pp(CFG.Absyn.Grammars foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Grammars)
    {
       CFG.Absyn.Grammars _grammars = (CFG.Absyn.Grammars) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_grammars.listgrammar_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.Grammar foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Grammar)
    {
       CFG.Absyn.Grammar _grammar = (CFG.Absyn.Grammar) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("grammar");
       pp(_grammar.ident_, 0);
       pp(_grammar.listflag_, 0);
       pp(_grammar.listrule_, 0);
       render("end");
       render("grammar");
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListGrammar foo, int _i_)
  {
     for (java.util.Iterator<Grammar> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("");
       } else {
         render("");
       }
     }
  }

  private static void pp(CFG.Absyn.Flag foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.StartCat)
    {
       CFG.Absyn.StartCat _startcat = (CFG.Absyn.StartCat) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("startcat");
       pp(_startcat.category_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListFlag foo, int _i_)
  {
     for (java.util.Iterator<Flag> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render(";");
       }
     }
  }

  private static void pp(CFG.Absyn.Rule foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Rule)
    {
       CFG.Absyn.Rule _rule = (CFG.Absyn.Rule) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_rule.ident_, 0);
       render(":");
       pp(_rule.name_, 0);
       pp(_rule.profile_, 0);
       render(".");
       pp(_rule.category_, 0);
       render("->");
       pp(_rule.listsymbol_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListRule foo, int _i_)
  {
     for (java.util.Iterator<Rule> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(";");
       } else {
         render(";");
       }
     }
  }

  private static void pp(CFG.Absyn.Profile foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Profile)
    {
       CFG.Absyn.Profile _profile = (CFG.Absyn.Profile) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("[");
       pp(_profile.listints_, 0);
       render("]");
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.Ints foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Ints)
    {
       CFG.Absyn.Ints _ints = (CFG.Absyn.Ints) foo;
       if (_i_ > 0) render(_L_PAREN);
       render("[");
       pp(_ints.listinteger_, 0);
       render("]");
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListInts foo, int _i_)
  {
     for (java.util.Iterator<Ints> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(",");
       } else {
         render("");
       }
     }
  }

  private static void pp(CFG.Absyn.ListInteger foo, int _i_)
  {
     for (java.util.Iterator<Integer> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render(",");
       } else {
         render("");
       }
     }
  }

  private static void pp(CFG.Absyn.Symbol foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.CatS)
    {
       CFG.Absyn.CatS _cats = (CFG.Absyn.CatS) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_cats.category_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
    if (foo instanceof CFG.Absyn.TermS)
    {
       CFG.Absyn.TermS _terms = (CFG.Absyn.TermS) foo;
       if (_i_ > 0) render(_L_PAREN);
       printQuoted(_terms.string_);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.ListSymbol foo, int _i_)
  {
     for (java.util.Iterator<Symbol> it = foo.iterator(); it.hasNext();)
     {
       pp(it.next(), 0);
       if (it.hasNext()) {
         render("");
       } else {
         render("");
       }
     }
  }

  private static void pp(CFG.Absyn.Name foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Name)
    {
       CFG.Absyn.Name _name = (CFG.Absyn.Name) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_name.singlequotestring_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }

  private static void pp(CFG.Absyn.Category foo, int _i_)
  {
    if (foo instanceof CFG.Absyn.Category)
    {
       CFG.Absyn.Category _category = (CFG.Absyn.Category) foo;
       if (_i_ > 0) render(_L_PAREN);
       pp(_category.singlequotestring_, 0);
       if (_i_ > 0) render(_R_PAREN);
    }
  }


  private static void sh(CFG.Absyn.Grammars foo)
  {
    if (foo instanceof CFG.Absyn.Grammars)
    {
       CFG.Absyn.Grammars _grammars = (CFG.Absyn.Grammars) foo;
       render("(");
       render("Grammars");
       render("[");
       sh(_grammars.listgrammar_);
       render("]");
       render(")");
    }
  }

  private static void sh(CFG.Absyn.Grammar foo)
  {
    if (foo instanceof CFG.Absyn.Grammar)
    {
       CFG.Absyn.Grammar _grammar = (CFG.Absyn.Grammar) foo;
       render("(");
       render("Grammar");
       sh(_grammar.ident_);
       render("[");
       sh(_grammar.listflag_);
       render("]");
       render("[");
       sh(_grammar.listrule_);
       render("]");
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListGrammar foo)
  {
     for (java.util.Iterator<Grammar> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.Flag foo)
  {
    if (foo instanceof CFG.Absyn.StartCat)
    {
       CFG.Absyn.StartCat _startcat = (CFG.Absyn.StartCat) foo;
       render("(");
       render("StartCat");
       sh(_startcat.category_);
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListFlag foo)
  {
     for (java.util.Iterator<Flag> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.Rule foo)
  {
    if (foo instanceof CFG.Absyn.Rule)
    {
       CFG.Absyn.Rule _rule = (CFG.Absyn.Rule) foo;
       render("(");
       render("Rule");
       sh(_rule.ident_);
       sh(_rule.name_);
       sh(_rule.profile_);
       sh(_rule.category_);
       render("[");
       sh(_rule.listsymbol_);
       render("]");
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListRule foo)
  {
     for (java.util.Iterator<Rule> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.Profile foo)
  {
    if (foo instanceof CFG.Absyn.Profile)
    {
       CFG.Absyn.Profile _profile = (CFG.Absyn.Profile) foo;
       render("(");
       render("Profile");
       render("[");
       sh(_profile.listints_);
       render("]");
       render(")");
    }
  }

  private static void sh(CFG.Absyn.Ints foo)
  {
    if (foo instanceof CFG.Absyn.Ints)
    {
       CFG.Absyn.Ints _ints = (CFG.Absyn.Ints) foo;
       render("(");
       render("Ints");
       render("[");
       sh(_ints.listinteger_);
       render("]");
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListInts foo)
  {
     for (java.util.Iterator<Ints> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.ListInteger foo)
  {
     for (java.util.Iterator<Integer> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.Symbol foo)
  {
    if (foo instanceof CFG.Absyn.CatS)
    {
       CFG.Absyn.CatS _cats = (CFG.Absyn.CatS) foo;
       render("(");
       render("CatS");
       sh(_cats.category_);
       render(")");
    }
    if (foo instanceof CFG.Absyn.TermS)
    {
       CFG.Absyn.TermS _terms = (CFG.Absyn.TermS) foo;
       render("(");
       render("TermS");
       sh(_terms.string_);
       render(")");
    }
  }

  private static void sh(CFG.Absyn.ListSymbol foo)
  {
     for (java.util.Iterator<Symbol> it = foo.iterator(); it.hasNext();)
     {
       sh(it.next());
       if (it.hasNext())
         render(",");
     }
  }

  private static void sh(CFG.Absyn.Name foo)
  {
    if (foo instanceof CFG.Absyn.Name)
    {
       CFG.Absyn.Name _name = (CFG.Absyn.Name) foo;
       render("(");
       render("Name");
       sh(_name.singlequotestring_);
       render(")");
    }
  }

  private static void sh(CFG.Absyn.Category foo)
  {
    if (foo instanceof CFG.Absyn.Category)
    {
       CFG.Absyn.Category _category = (CFG.Absyn.Category) foo;
       render("(");
       render("Category");
       sh(_category.singlequotestring_);
       render(")");
    }
  }


  private static void pp(Integer n, int _i_) { buf_.append(n); buf_.append(" "); }
  private static void pp(Double d, int _i_) { buf_.append(d); buf_.append(" "); }
  private static void pp(String s, int _i_) { buf_.append(s); buf_.append(" "); }
  private static void pp(Character c, int _i_) { buf_.append("'" + c.toString() + "'"); buf_.append(" "); }
  private static void sh(Integer n) { render(n.toString()); }
  private static void sh(Double d) { render(d.toString()); }
  private static void sh(Character c) { render(c.toString()); }
  private static void sh(String s) { printQuoted(s); }
  private static void printQuoted(String s) { render("\"" + s + "\""); }
  private static void indent()
  {
    int n = _n_;
    while (n > 0)
    {
      buf_.append(" ");
      n--;
    }
  }
  private static void backup()
  {
   String s = buf_.toString();

     if (s.substring(buf_.length() - 1, buf_.length()).equals(" ")) {
       buf_.setCharAt(buf_.length() - 1, '\"');
       buf_.setLength(buf_.length() - 1);
     }
  }
  private static void trim()
  {
     while (buf_.length() > 0 && buf_.charAt(0) == ' ')
        buf_.deleteCharAt(0); 
    while (buf_.length() > 0 && buf_.charAt(buf_.length()-1) == ' ')
        buf_.deleteCharAt(buf_.length()-1);
  }
  private static int _n_ = 0;
  private static StringBuilder buf_ = new StringBuilder(INITIAL_BUFFER_SIZE);
}

