package se.chalmers.cs.gf.abssyn;

/**
 *  An integer literal in untyped abstract syntax trees.
 */
public class IntLiteral implements Tree {

        private int value;

        public IntLiteral(int value) {
                this.value = value;
        }

        public boolean isLiteral() {
                return true;
        }

        public int getValue() {
                return value;
        }

        public String toString() {
                return String.valueOf(value);
        }

        public boolean equals(Object o) {
                return o instanceof IntLiteral && equals((IntLiteral)o);
        }

        public boolean equals(IntLiteral l) {
                return value == l.value;
        }

        public int hashCode() {
                return value;
        }

        public <R,A> R accept(TreeVisitor<R,A> v, A arg) {
                return v.visit(this, arg); 
        }

}
