package se.chalmers.cs.gf.gfcutil;

import GFC.Absyn.*;

public enum ModuleType { 
        ABSTRACT, CONCRETE, RESOURCE, TRANSFER; 

        public static ModuleType getModuleType(ModType t) {
                return t.accept(new GetModuleType(), null);
        }

        /**
         *  Gets the type of a module.
         */
        private static class GetModuleType implements ModType.Visitor<ModuleType,Object> { 
                public ModuleType visit(GFC.Absyn.MTAbs p, Object arg) { return ABSTRACT; }
                public ModuleType visit(GFC.Absyn.MTCnc p, Object arg) { return CONCRETE; }
                public ModuleType visit(GFC.Absyn.MTRes p, Object arg) { return RESOURCE; }
                public ModuleType visit(GFC.Absyn.MTTrans p, Object arg) { return TRANSFER; }
        }

}
