package se.chalmers.cs.gf.linearize;

import java.util.List;
import java.util.regex.Pattern;

/**
 *  Glues together strings in linearization.
 */
public class Unlexer {

        private static Unlexer instance = new Unlexer();

        public Unlexer() {}

        public String unlex(String s1, String s2) {
//                System.err.println("unlex(" + s1 + "," + s2 + ")");

                if (noSpaceAfter(s1) || noSpaceBefore(s2)) {
                        return s1 + s2;
                } else {
                        return s1 + " " + s2;
                }
        }

        private Pattern noSpaceAfterPatt = Pattern.compile("^[\\(\\-\\[]"); 
        private boolean noSpaceAfter(String s) {
                return s.length() == 0 || noSpaceAfterPatt.matcher(s).find();
        }

        private Pattern noSpaceBeforePatt = Pattern.compile("^[\\.\\,\\?\\!\\)\\:\\;\\-\\]]"); 
        private boolean noSpaceBefore(String s) {
                return s.length() == 0 || noSpaceBeforePatt.matcher(s).find();
        }

        public static Unlexer getInstance() {
                return instance;
        }

}
