package se.chalmers.cs.gf.parse;

import se.chalmers.cs.gf.GFException;

import java.util.*;

/**
 *  A collection of parsers.
 */
public class Parsers {

        protected Map<String,Parser> map;

        public Parsers() {
                map = new TreeMap<String,Parser>();
        }

        /**
         *  Get a parser by name.
         */
        public Parser getParser(String lang) {
                Parser parser = map.get(lang);

                if (parser == null) 
                        throw new GFException("There is no parser for " + lang);

                return parser;
        }

        /**
         * 
         */
        public void addParser(Parser parser) {
                String lang = parser.getName();
                if (map.containsKey(lang)) 
                        throw new GFException("There is already a parser for " + lang);
                map.put(lang, parser);
        }

        public Set<String> listParsers() {
                return map.keySet();
        }

}
