package se.chalmers.cs.gf.parse.chart;

import java.util.*;

/**
 *  An empty CF grammar production.
 */
public class EmptyRule extends Rule {

        private String fun;

        private int argCount;

        /**
         * @param argCount The number of arguments needed by the function
         *  that this rule represents.
         */ 
        public EmptyRule(String name, Category cat, String fun, int argCount) {
                super(name, cat);
                this.fun = fun;
                this.argCount = argCount;
        }

        public String getFun() {
                return fun;
        }

        public int getSize() {
                return 0;
        }

        public boolean isTerminal() {
                return true;
        }

        public int getArgCount() {
                return argCount;
        }

        public int hashCode() {
                return fun.hashCode() + argCount;
        }

        public boolean equals(Object o) {
                return o instanceof EmptyRule && equals((EmptyRule)o);
        }

        public boolean equals(EmptyRule r) {
                return getName().equals(r.getName()) && argCount == r.argCount;
        }

        public String toString() {
                StringBuilder sb = new StringBuilder();
                sb.append(getName());
                sb.append("[");
                for (int i = 0; i < argCount; i++) {
                        sb.append("[]");
                        if (i < argCount-1)
                                sb.append(",");
                }
                sb.append("]");
                sb.append(". ");
                sb.append(getCategory());
                sb.append(" -> ");

                return sb.toString();
        }

}
