package se.chalmers.cs.gf.parse.chart;

import se.chalmers.cs.gf.abssyn.*;

import java.util.*;

public class TerminalRule extends Rule {

        private Terminal terminal;

        public TerminalRule(String name, Category cat, Terminal terminal) {
                super(name, cat);
                this.terminal = terminal;
        }

        public boolean matches(Token token) {
                return terminal.matches(token);
        }

        public String getFun() {
                return getName(); // FIXME: should we really use name here?
        }

        public int getSize() {
                return 1;
        }

        public boolean isTerminal() {
                return true;
        }

        /**
         *  Build an abstract syntax tree from this rule. Since this is a
         *  terminal rule, we don't need to know about the children.
         */
        public Tree makeTree(Token token) {
                return new Fun(getFun());
        }

        public boolean equals(Object o) {
                return o instanceof TerminalRule && equals((TerminalRule)o);
        }

        public boolean equals(TerminalRule r) {
                return getName().equals(r.getName()) && terminal.equals(terminal);
        }

        public int hashCode() {
                return getName().hashCode() + terminal.hashCode();
        }

        public String toString() {
                StringBuilder sb = new StringBuilder();
                sb.append(getName());
                sb.append(". ");
                sb.append(getCategory());
                sb.append(" -> ");
                sb.append(terminal);

                return sb.toString();
        }

}
